DEBUG = false

ERROR_WRONG_PARAMETERS = 10
ERROR_NAME_TAKEN = 20
ERROR_INVALID_USER = 30

WINNER_TIME_IN_BOUND = 3
WINNER_BOUND = 5

G_PORT = 12345
B_PORT = 7777
B_ADDRESS = "255.255.255.255"

B_CLIENT_MESSAGE = "Who's a server?"
B_SERVER_MESSAGE = "I'm a server :D"

GIVE_FREQUENCY = 1
PLAYER_LIMIT = 16
KARMA_BOUND = 40
WINNER_BOUND = 5
WINNER_TIME_IN_BOUND = 3
WINNER_TIMEOUT = 10

function debug(out)
	if DEBUG then
		print(out)
	end
end

function string:split(sep)
	local sep, fields = sep or ":", {}
	local pattern = string.format("([^%s]+)", sep)
	self:gsub(pattern, function(c) fields[#fields+1] = c end)
	return fields
end

function join(field, delimiter)
	debug("Join " .. tostring(field) .. " with " .. delimiter)
	return table.concat(field, delimiter)
end

function expandCommand(data)
	local parts = data:split(":")
	local params = {}
	if #parts > 1 then
		params = parts[2]:split(",")
	end
	return parts[1], params
end

function printTableRec(myTable, depth)
	for k, v in pairs(myTable) do
		if type(v) == "table" then
			i = 0
			tabs = ""
			for i = 0,depth,1 do tabs = tabs .. "\t" end
			debug(tabs .. k .. " = ")
			printTableRec(v, depth + 1)
		else
			i = 0
			tabs = ""
			for i = 0,depth,1 do tabs = tabs .. "\t" end
			debug(tabs .. k .. " = " .. v)
		end
	end
end

function printTable(myTable)
	debug("Printing table:")
	printTableRec(myTable, 0)
end
