require("common")
require("client")
require("ui")
require("os")

users = {}

---- fill user list with debug users:
--[[users = {first = {karma = 20, sinOffset1 = math.random(99), sinOffset2 = math.random(99)},
second = {karma = -25, sinOffset1 = math.random(99), sinOffset2 = math.random(99)},
third = {karma = -100, sinOffset1 = math.random(99), sinOffset2 = math.random(99)},
fourth = {karma = 100, sinOffset1 = math.random(99), sinOffset2 = math.random(99)},
fifth = {karma = 20, sinOffset1 = math.random(99), sinOffset2 = math.random(99)},
six = {karma = 20, sinOffset1 = math.random(99), sinOffset2 = math.random(99)},
seven = {karma = 20, sinOffset1 = math.random(99), sinOffset2 = math.random(99)},
nine = {karma = 20, sinOffset1 = math.random(99), sinOffset2 = math.random(99)},
ten = {karma = 20, sinOffset1 = math.random(99), sinOffset2 = math.random(99)},
eleven = {karma = 5, sinOffset1 = math.random(99), sinOffset2 = math.random(99)},
twelve = {karma = 4, sinOffset1 = math.random(99), sinOffset2 = math.random(99)},
thirteen = {karma = 0, sinOffset1 = math.random(99), sinOffset2 = math.random(99)},
fifteen = {karma = 20, sinOffset1 = math.random(99), sinOffset2 = math.random(99)},
sixteen = {karma = 20, sinOffset1 = math.random(99), sinOffset2 = math.random(99)},
seventeen = {karma = 20, sinOffset1 = math.random(99), sinOffset2 = math.random(99)},
nineteen = {karma = 20, sinOffset1 = math.random(99), sinOffset2 = math.random(99)}
}]]--


servers = {}

roundRunning = false
winnerName = ""

function love.load()
	math.randomseed(os.time())
	love.graphics.setBackgroundColor(131, 157 , 179)
	setupGraphics()
	initMainMenu()
	newStatusMsg("Welcome! Hold F1 for Help")
	setupBroadcast()
end

local timeSinceLastCall = 0
local timeSinceLastRequest = 0

function love.draw(dt)
	clearButtons()
	
	drawKarmaGiven()

	drawBorders()
	if not getIsConnected() then
		showMainMenu()
	else
		showPlayers()
	end
	
	
	showStatusMessage(dt)
	
	drawButtons()		--make sure buttons are drawn last
	
end


function love.update()
	local dt = socket.gettime() - timeSinceLastCall		-- more accurate than love's dt
	timeSinceLastCall = socket.gettime()
	receiveData()					-- check if new data has arrived at the socket
	countDownStatusMsg(dt)
	checkForTimeOut()
	coolDownKarmaSend(dt)
	receiveBroadcast()
	timeSinceLastRequest = timeSinceLastRequest + dt
	
	if timeSinceLastRequest > 5 and getIsConnected() == false then 
		timeSinceLastRequest = 0
		sendBroadcast()
	end
end

function love.mousepressed(x, y, mButton)
	if mButton == "l" then
		checkForButtonPressed(x, y)
	end
end


function love.keypressed(key, code)
	-- only allow numbers and letters:
	if (code >= 97 and code <= 122) or (code >= 65 and code <= 90) or (code >= 48 and code <= 57) or code == 46 then
		if love.keyboard.isDown("rshift") or love.keyboard.isDown("lshift") then
			code = code - 32
			key = key:upper()
		end
		newInput(key)				-- send to UI
	elseif code == 8 then			-- backspace
		deleteLastInput()
	elseif code == 13 then			-- enter
		inputFinished()
	end
end

function love.quit()
	print("Leaving game")
	disconnect()
end