local plNameInput = false		-- currently typing playername
local ipInput = false		-- currently typing ip address
local inputStr = ""
local plNameString = ""
local ipStr = ""

local maxKarma = 40

-- Images: ------------------------------------
local avatar
local myAvatar
local minus
local plus
local broderRight
local broderLeft
------------------------------------------------

local buttons = {}

local myFont = love.graphics.newFont(14)
local myLargeFont = love.graphics.newFont(20)
love.graphics.setFont(myFont)

function resetMenu()
	plNameString = ""
	ipStr = ""
	ipInput = false
	plNameInput = false
	initMainMenu()
end

function drawBorders()
	love.graphics.setColor(255,255,255,255)
	love.graphics.draw(borderRight, 0, 0)
	love.graphics.draw(borderLeft, love.graphics.getWidth() - borderLeft:getWidth(), 0)
	love.graphics.draw(borderBottom, (love.graphics.getWidth() - borderBottom:getWidth())/2, love.graphics.getHeight() - borderBottom:getHeight())
end

function setupGraphics()			--load all required images at startup
	avatar = love.graphics.newImage( "Dot.png" )
	myAvatar = love.graphics.newImage( "DotPlayer.png" )
	minus = love.graphics.newImage("Minus.png")
	plus = love.graphics.newImage("Plus.png")
	borderRight = love.graphics.newImage("bg_left.png")
	borderLeft = love.graphics.newImage("bg_right.png")
	borderBottom = love.graphics.newImage("bg_bottom.png")
end


function newInput(str)
	if str ~= nil then
		if #str < 30 then
			if str ~= "." or ipInput == true then
				inputStr = inputStr .. str
				debug (inputStr)
			end
		end
	end
end

function deleteLastInput()			-- when backspace was pressed, delete last charater
	if #inputStr > 0 then
		inputStr = string.sub(inputStr, 1, #inputStr-1)
	end
end

function inputFinished()
	if plNameInput == true then
		if #inputStr > 0 then
			plNameInput = false
			plNameString = inputStr
			inputStr = ""
			ipInput = true
		end
	elseif ipInput == true then
		if #inputStr > 0 then
			ipInput = false
			ipStr = inputStr
			inputStr = ""
		end
		connect(ipStr, plNameString)
	end
end


function showMainMenu()
	love.graphics.setFont(myLargeFont)
	love.graphics.setColor(0,0,0)
	love.graphics.print("Welcome to Karma Exchange", 70, 55)
	love.graphics.setFont(myFont)
	if plNameInput == true then
		love.graphics.print("Enter Playername: " .. inputStr, 70, 75)
	elseif ipInput == true then
		love.graphics.print("Enter IP (or wait for serverlist to load): " .. inputStr, 70, 75)
		local i = 1
		for ip, available in pairs(servers) do
			if available then
				love.graphics.print(ip, 80, 85 + i * 20)
				table.insert(buttons, {
					myX = 75,
					myY =  83 + i * 20,
					width = love.graphics.getWidth()-160,
					height = 18,
					event = chooseServer,
					params = ip,
					kind = "rectangle",
				})
				--love.graphics.rectangle( "fill" , 55, 83 + i * 20, love.graphics.getWidth()-110, 18 )
				i = i + 1
			end
		end
	end
end

function initMainMenu()
	plNameInput = true
end

function getMyPlayerName()
	return plNameString
end

function showPlayers()
	local numOfPlayers = 0
	for key, value in pairs(users) do				--count number of active users
		numOfPlayers = numOfPlayers + 1
	end
	
	local spacePerPlayer = 100		--default vertical space between players.
	local xOfNames = 20
	local yOfPlayerList = 60
	
	local centerXOfKarma = (love.graphics.getWidth() - 250)/2 + 190
	local pixelsPerKarma = (love.graphics.getWidth() - 250)/maxKarma
	
	--draw lines indicating 0, 5, -5, -100 and 100 karma
	love.graphics.setColor(0,0,0, 255)
	love.graphics.line(centerXOfKarma, 0, centerXOfKarma, love.graphics.getHeight())
	love.graphics.setColor(100,100,150, 50)
	love.graphics.line(centerXOfKarma + WINNER_BOUND*pixelsPerKarma, 0, centerXOfKarma+5*pixelsPerKarma, love.graphics.getHeight())
	love.graphics.line(centerXOfKarma - WINNER_BOUND*pixelsPerKarma, 0, centerXOfKarma-5*pixelsPerKarma, love.graphics.getHeight())
	love.graphics.setColor(150,100,100, 150)
	love.graphics.line(centerXOfKarma+100*pixelsPerKarma, 0, centerXOfKarma+100*pixelsPerKarma, love.graphics.getHeight())
	love.graphics.line(centerXOfKarma-100*pixelsPerKarma, 0, centerXOfKarma-100*pixelsPerKarma, love.graphics.getHeight())
	
	
	if numOfPlayers > 0 then 
		spacePerPlayer = (love.graphics.getHeight() - yOfPlayerList)/(numOfPlayers-1);
	end
	--print my player:
	love.graphics.setColor(255,255,255, 175)
	love.graphics.rectangle("fill", 0, yOfPlayerList/2-myAvatar:getHeight()/2 - 3, love.graphics.getWidth(), myAvatar:getHeight() + 6)
	love.graphics.setFont(myLargeFont)
	love.graphics.setColor(0,0,0, 255)
	love.graphics.print(plNameString .. ":", xOfNames, yOfPlayerList/2-myAvatar:getHeight()/2)
	if users[plNameString] ~= nil then
		love.graphics.print(users[plNameString]["karma"], xOfNames + myLargeFont:getWidth( plNameString .. ":" ), yOfPlayerList/2-myAvatar:getHeight()/2)
		love.graphics.setColor(255,255,255, 255)
		love.graphics.draw(myAvatar, centerXOfKarma - myAvatar:getWidth()/2 + pixelsPerKarma*users[plNameString]["karma"], yOfPlayerList/2-myAvatar:getHeight()/2)
	end
	
	
	if not roundRunning then
		love.graphics.setColor(0,0,64, 100)
		love.graphics.rectangle("fill", 0, love.graphics.getHeight()/2 - 50, love.graphics.getWidth(), 100)
		love.graphics.setColor(0,0,64, 100)
		love.graphics.rectangle("fill", 0, love.graphics.getHeight()/2 - 40, love.graphics.getWidth(), 80)
		love.graphics.setColor(255,255,255, 255)
		love.graphics.setFont(myLargeFont)
		love.graphics.print("Winner is: " .. winnerName, love.graphics.getWidth()/2 - myLargeFont:getWidth( "Winner is: " .. winnerName)/2, love.graphics.getHeight()/2-20)
	end
	
	love.graphics.setFont(myFont)
	
	local i = 0
	for key, value in pairs(users) do
		if key ~= plNameString then			--don't print my own player name in the list of players
		
			if roundRunning or winnerName == key then
				local x = centerXOfKarma + pixelsPerKarma*value["karma"]
				local y = yOfPlayerList + spacePerPlayer*i

				
				
				love.graphics.setColor(255,255,255, 100)
				love.graphics.rectangle("fill", 0, yOfPlayerList + spacePerPlayer*i, love.graphics.getWidth(), math.min(spacePerPlayer, avatar:getHeight()))
				love.graphics.setColor(0,0,0, 50)
				love.graphics.line(0, yOfPlayerList + spacePerPlayer*i, love.graphics.getWidth(), yOfPlayerList + spacePerPlayer*i)
			
				
				love.graphics.setColor(0,0,0, 255)
				love.graphics.print(key .. ": ", xOfNames, yOfPlayerList + spacePerPlayer*i)
				love.graphics.print(value["karma"], xOfNames + myFont:getWidth( key .. ":" ), yOfPlayerList + spacePerPlayer*i)
				love.graphics.setColor(255,255,255)
				love.graphics.draw(avatar, x - avatar:getWidth()/2, y)
			
				value["y"] = y			-- save where I was last placed
				
				table.insert(buttons, {img = minus,
										myX = x - avatar:getWidth()/2 - minus:getWidth() - 5,
										myY = y - (minus:getHeight() - avatar:getHeight())/2,
										event = sendKarma,
										params = {key, "-"},
										kind = "circle",
										myOffset = y + value["sinOffset1"]			--random value for sin movement
				})
				table.insert(buttons, {img = plus,
										myX = x + avatar:getWidth()/2 + 5,
										myY = y - (minus:getHeight() - avatar:getHeight())/2,
										event = sendKarma,
										params = {key, "+"},
										kind = "circle",
										myOffset = y + value["sinOffset2"]			--random value for sin movement
				})
			end
			i = i + 1
		end
	end
	
end

function clearButtons()
	buttons = {}
end

function drawButtons()
	love.graphics.setColor(255,255,255)
	for key, value in pairs(buttons) do
		if value["kind"] == "circle" then
			love.graphics.draw(value["img"], value["myX"], value["myY"] + 3*math.sin(value["myOffset"] + socket.gettime()*1.5))
		end
		if value["kind"] == "rectangle" then
			love.graphics.setColor(255,255,255, 100)
			love.graphics.rectangle("fill", value["myX"], value["myY"], value["width"], value["height"])
		end
	end
end

function checkForButtonPressed(inX, inY)
	for key, value in pairs(buttons) do
		if value["kind"] == "circle" then
			if checkIsInCircle(inX, inY, value["myX"] + value["img"]:getWidth()/2, value["myY"] + value["img"]:getHeight()/2, value["img"]:getWidth()/2) then
				value["event"](value["params"])
				return true
			end
		elseif value["kind"] == "rectangle" then
			if checkIsInRectangle(inX, inY, value["myX"], value["myY"], value["width"], value["height"]) then 
				value["event"](value["params"])
				return true
			end
		end
	end
	return false
end

function checkIsInCircle(posX, posY, centerX, centerY, radius)
	return (math.sqrt((posX-centerX)*(posX-centerX) + (posY-centerY)*(posY-centerY)) <= radius)
end

function checkIsInRectangle(posX, posY, startX, startY, width, height)
	return ( posX > startX and posX < startX + width and posY > startY and posY < startY + height )
end

-- Show Karma Given --------------------------------------------------------------------

local givenKarmas = {}

function addNewGivenKarma(player, direction, wasGoodForYou)
	if users[player] ~= nil then
		table.insert(givenKarmas, {playerName = player, startX = 30, dir = direction, startTime = socket.gettime(), karmaWasGoodForYou = wasGoodForYou})
	end
end

function drawKarmaGiven()
	love.graphics.setColor( 255, 255, 255, 150 )
	for key, value in pairs(givenKarmas) do
		-- check if the player who gave me karma still exists and the karma has been displayed for less than 3 seconds
		if users[value["playerName"]] ~= nil and socket.gettime() - value["startTime"] < 10 then
			
			if value["dir"] == "+" then
				love.graphics.draw(plus, value.startX + math.pow(1+10*(socket.gettime() - value["startTime"]), 2), users[value["playerName"]]["y"] + (avatar:getHeight()-plus:getHeight())/2)
			else
				love.graphics.draw(minus, value.startX + math.pow(1+10*(socket.gettime() - value["startTime"]), 2),users[value["playerName"]]["y"] + (avatar:getHeight()-plus:getHeight())/2)
			end
		else
			givenKarmas[key] = nil		-- if the player does no longer exist, remove the entry
		end
	end
	love.graphics.setColor( 255, 255, 255, 255 )
end

-- Error/Status Messages: ----------------------------------------------------
local msgCountDown = 0
local lastStatusMsg = ""

function showStatusMessage(dt)
	if msgCountDown > 0 then
		love.graphics.setFont(myFont)
		love.graphics.setColor(255,255,255,255)
		love.graphics.print(lastStatusMsg, love.graphics.getWidth()/2-myFont:getWidth(lastStatusMsg)/2 , love.graphics.getHeight()-20)
	end
end

function newStatusMsg(msg)
	msgCountDown = 10
	lastStatusMsg = msg
end

function getStatusMsg()
	return lastStatusMsg
end

function countDownStatusMsg(dt)
	if msgCountDown > 0 then
		msgCountDown = msgCountDown - dt
	end
end
-----------------------------------------------------------------------------